/*
Libsynth Example Instruments - Magichord
Copyright (C) 2019 Ryan Medeiros

  This file is part of libsynth_instpack.

    libsynth_instpack is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    libsynth_instpack is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with libsynth_instpack.  If not, see <https://www.gnu.org/licenses/>.
    
You may contact me at lofenyy (at) linuxmail (dot) org. 
*/

#include<string.h>
#include"libsynth/libsynth.h"

double keys_c[12] = {0}; //timing
double keys_o[12] = {0}; //output
double keys_f[12] = {0}; //frequency

double play(char* note, double octave, double sample_rate)
	{
	int i = 0; //key index
	double o = 0; //Stores the entire signal
	
	//If the current note is a rest, reset counter and play at 0Hz
	if(strcmp(note, "R") == 0)
		{
		for(i = 0;i<12;i++)
			{
			keys_c[i] = 0;
			keys_f[i] = 0;
			}
		}
	//Otherwise, reset the counter and play at appropriate frequency.
	else
		{
		i = 13;
		     if(strcmp(note, "C" ) == 0) i =  0;
		else if(strcmp(note, "C#") == 0) i =  1;
		else if(strcmp(note, "D" ) == 0) i =  2;
		else if(strcmp(note, "D#") == 0) i =  3;
		else if(strcmp(note, "E" ) == 0) i =  4;
		else if(strcmp(note, "F" ) == 0) i =  5;
		else if(strcmp(note, "F#") == 0) i =  6;
		else if(strcmp(note, "G" ) == 0) i =  7;
		else if(strcmp(note, "G#") == 0) i =  8;
		else if(strcmp(note, "A" ) == 0) i =  9;
		else if(strcmp(note, "A#") == 0) i = 10;
		else if(strcmp(note, "B" ) == 0) i = 11;
		
		keys_c[i] = 0;
		keys_f[i] = note2freq(note,octave);
		}
	
	//Render all 12 independent voices.
	for(i = 0;i<12;i++)
		{
		keys_c[i]++;
		keys_o[i] =
			(
			synth_Env(keys_c[i],0,1,0, 1.0 ,sample_rate)*
			synth_Env(keys_c[i],0,1,0, 1.0 ,sample_rate)*
			(
		synth_Sine(keys_c[i],(1.0/8.0),0.5*keys_f[i],sample_rate)+
		synth_Sine(keys_c[i],(1.0/8.0),2.0*keys_f[i],sample_rate)
			)
			)/2;
		}
	//Mix all voices into one giant loud lossless signal
	for(i = 0;i<12;i++)
		{
		o = keys_o[i] +o;
		}
	
	//return the signal at 1/12th of the volume. 
	return o/12.0;
	}

